#include "parsedtcolor.h"
#include "qdebug.h"
#include "qpixmap.h"
#include "qimage.h"
#include <QFile>
#include <QSize>
#include <QApplication>
#include <QPalette>
#include <QColor>
#include <qmath.h>

using namespace UKUIQQC2Style;


ParseDTColor::ParseDTColor(QObject *parent):QObject(parent)
{

}

ParseDTColor* ParseDTColor::qmlAttachedProperties(QObject* parent)
{
    auto p = qobject_cast<QObject*>(parent);
    return new ParseDTColor(p);
}


bool ParseDTColor::isSolidPattern(QVariant dtColor)
{
    if(dtColor.canConvert<DTColor>()){
        DTColor c = dtColor.value<DTColor>();
        return (c.colorType() == Qt::SolidPattern);
    }
    return false;
}

QColor ParseDTColor::startColor(QVariant dtColor)
{
    if(dtColor.canConvert<DTColor>()){
        DTColor c = dtColor.value<DTColor>();
        return c.mixStartColor();
    }
    return QColor();
}

QColor ParseDTColor::endColor(QVariant dtColor)
{
    if(dtColor.canConvert<DTColor>()){
        DTColor c = dtColor.value<DTColor>();
        return c.mixEndColor();
    }
    return QColor();
}

