
import QtQuick 2.6
import QtGraphicalEffects 1.0
import QtQuick.Templates 2.5 as T
import org.ukui.qqc2style.private 1.0 as StylePrivate

T.Popup {
    id: control

    palette: StylePrivate.APPParameter.palette
    font: StylePrivate.APPParameter.font

    implicitWidth: Math.max(background ? background.implicitWidth : 0,
                            contentWidth > 0 ? contentWidth + leftPadding + rightPadding : 0)
    implicitHeight: Math.max(background ? background.implicitHeight : 0,
                             contentWidth > 0 ? contentHeight + topPadding + bottomPadding : 0)

    contentWidth: contentItem.implicitWidth || (contentChildren.length === 1 ? contentChildren[0].implicitWidth : 0)
    contentHeight: contentItem.implicitHeight || (contentChildren.length === 1 ? contentChildren[0].implicitHeight : 0)

    padding: StylePrivate.UKUIPopup.padding
    clip: false

//    StylePrivate.APPParameter{
//        id: appP
//    }
//    StylePrivate.UKUIPopup{
//        id: popup
//    }
//    ParseInterface{
//        id: parseInterface
//    }

//    function getStartColor(dtcolor)
//    {
//        return parseInterface.pStartColor(dtcolor)
//    }
//    function getEndColor(dtcolor)
//    {
//        return parseInterface.pEndColor(dtcolor)
//    }

    enter: Transition {
        NumberAnimation {
            property: "opacity"
            from: 0
            to: 1
            easing.type: Easing.InOutQuad
            duration: 250
        }
    }

    exit: Transition {
        NumberAnimation {
            property: "opacity"
            from: 1
            to: 0
            easing.type: Easing.InOutQuad
            duration: 250
        }
    }

    contentItem: Item { }

    background: Rectangle {
        radius: StylePrivate.UKUIPopup.radius
        color: gradientRec.visible ? "transparent" : StylePrivate.ParseDTColor.startColor(StylePrivate.UKUIPopup.backColor)
        border.color: StylePrivate.ParseDTColor.startColor(StylePrivate.UKUIPopup.backBorderColor)
        layer.enabled: true

        Rectangle{
            id: gradientRec
            anchors.fill: parent
            radius: parent.radius
            border.width: parent.border.width
            border.color: parent.border.color
            gradient:  Gradient {
                id:gradient
                GradientStop { position: 0.0; color: StylePrivate.ParseDTColor.startColor(StylePrivate.UKUIPopup.backColor) }

                GradientStop { position: 1.0; color: StylePrivate.ParseDTColor.endColor(StylePrivate.UKUIPopup.backColor)}
            }
            visible: !StylePrivate.ParseDTColor.isSolidPattern(StylePrivate.UKUIPopup.backColor)
        }


        layer.effect: DropShadow {
            transparentBorder: true
            radius: StylePrivate.UKUIPopup.radius
            samples: 16
            horizontalOffset: -4
            verticalOffset: -4
            width: background.width + 8
            height: background.height + 8
            color: StylePrivate.ParseDTColor.startColor(StylePrivate.UKUIPopup.shadowColor)
        }
    }
}
