import QtQuick 2.0
import QtQuick.Templates 2.5 as T
import QtQuick.Layouts 1.3
import QtQuick.Controls 2.0
import QtGraphicalEffects 1.0
import org.ukui.qqc2style.private 1.0 as StylePrivate



Rectangle {
    id:rect1
    implicitWidth: controlRoot.width

    implicitHeight: controlRoot.height
    property T.AbstractButton controlRoot: root.parent
    property int _radius : 6
    property bool useGradient: (ncColor.controlStartColor !== ncColor.controlEndColor)

    color: gradientRec.visible ? "transparent" : ncColor.controlStartColor
    opacity: (controlRoot.flat && !controlRoot.pressed && !controlRoot.hovered) ? 0 : 1
    radius: _radius // 可选：设置圆角半径
    border.width: controlRoot.focus ? StylePrivate.UKUIButton.focusBorderWidth : StylePrivate.UKUIButton.borderWidth
    border.color: ncColor.borderColor



    Rectangle {
        id: gradientRec
        anchors.fill: parent
        radius: _radius // 可选：设置圆角半径
        border.width: parent.border.width
        border.color: parent.border.color

        gradient:  Gradient {
            id:gradient
            GradientStop { position: 0.0; color: ncColor.controlStartColor }

            GradientStop { position: 1.0; color: ncColor.controlEndColor }
        }
        visible: useGradient
    }

    NormalControlColor{
        id:ncColor
    }

    Component.onCompleted: {
        ncColor.changeColor(controlRoot.highlighted, controlRoot.enabled, false, false, false);
    }

    Connections {
        target: controlRoot
        function onPressedChanged() {
            ncColor.changeColor(controlRoot.highlighted, controlRoot.enabled, controlRoot.pressed, controlRoot.hovered, controlRoot.focus)
        }
        function onHoveredChanged() {
            //            if(controlRoot.hovered)
            //                grad.visible = true;
            //            else
            //                grad.visible = false;
            ncColor.changeColor(controlRoot.highlighted, controlRoot.enabled, false, controlRoot.hovered, controlRoot.focus)
        }
        function onFocusChanged(){
            ncColor.changeColor(controlRoot.highlighted, controlRoot.enabled, controlRoot.pressed, controlRoot.hovered, controlRoot.focus)
        }
    }
}

